# .qtre.pl
#	qtre: Quick Tool for Raw Editing.
#	(C) 2000-2004 Julian Albo.
#	Definiciones de macros.

# Revision 10-oct-2004

use strict;

#use diagnostics;

#no warnings 'redefine';

qtre::mode 1;

#qtre::insert "Hello, world";

#qtre::help_add_func ('tonteria', 'Esta es la ayuda de tonteria');

sub qtre::insert_some
{
	qtre::insert "Hola\nQue tal\nMuy bien.\nGracias\n";
}

sub qtre::test_dialog
{
	qtre::dialog_show_text "Test", "This is a test", 10, 6
}

#qtre::define_control 'K', 'macro';

qtre::define_control 'L', 'redraw';

#qtre::define_control 'Z', 'insert_some';
qtre::define_control 'Z', 'test_dialog';

#my $old_redraw= \&qtre::redraw;
#
#sub qtre::new_redraw
#{
#	&$old_redraw ();
#	qtre::status "Hola, redraw";
#}
#
#*qtre::redraw= \&qtre::new_redraw;

my $old_delete_line= \&qtre::delete_line;

sub new_delete_line
{
	&$old_delete_line;
	qtre::status "Line deleted";
}

*qtre::delete_line= \&new_delete_line;

my $old_delete_char= \&qtre::delete_char;

sub new_delete_char
{
	&$old_delete_char;
	qtre::status "Char deleted";
}

*qtre::delete_char= \&new_delete_char;

#my $old_home= \&qtre::home;

#sub new_home
sub qtre::home
{
	#&$old_home;
	qtre::default::home ();
	qtre::status "Homing";
}

#*qtre::home= \&new_home;

my $old_pageup= \&qtre::pageup;

sub new_pageup
{
	&$old_pageup;
	qtre::status "Paging up";
}

*qtre::pageup= \&new_pageup;

my $old_load= \&qtre::file_load;

sub new_load
{
	qtre::status "Option load";
	qtre::file_new unless (qtre::empty && ! qtre::modified);
	&$old_load;
}

*qtre::file_load= \&new_load;

my $old_save= \&qtre::file_save;

#sub new_save
#{
#	qtre::status "Option save";
#	&$old_save;
#}
#
#*qtre::file_save= \&new_save;

sub qtre::before_load ()
{
	my ($uno, $dos, $tres)= @_;
	qtre::status 'Before loading ' . @_ . ': "' . $uno . '", "'. $dos . '", "' . $tres . '"';
	#qtre::get_key;
}

sub after_load
{
#	my $file= shift @_;
#	qtre::status "After loading $file";
	my ($uno, $dos, $tres)= @_;
	qtre::status 'After loading ' . @_ . ': "' . $uno . '", "'. $dos . '", "' . $tres . '"';
}

sub qtre::boberia ()
{
	print "Esto es una boberia\n";
	print STDERR "Y esto tambien\n";
}

#qtre::define_control 'q', 'boberia';

#my $guarda;

# Como definir macros no alfanumericas:

sub qtre::macro_ctrl_k ()
{
	die "Ay que doloooooor";
	qtre::insert ("\nEsta es la macro ctrl_k\n");
}

sub qtre::macro_3A ()
{
	qtre::insert ("\nEsta es la macro ':'\n");
}

sub qtre::macro_1 ()
{
	#qtre::status ("Probando, probando");
	#print "Hola", 1, "que tal\n";
	#printf "%i-%s-%i\n", 123, "jeje", 456;

	#my $r= qtre::status_question ("hola", "sSnN");
	#qtre::status ("La respuesta es " . $r);

	my $str= qtre::dialog_get_string ("Title", "Prompt", 60, 60,
		"123456789012345678901234567890");
	if (defined ($str) )
	{
		qtre::status ("La respuesta es: " . $str);
	}
}

sub qtre::macro_2 ()
{
	#qtre::insert ("'Hola, mundo', dicen los clsicos\n");
	qtre::dialog_show_text "Ttulo",
		"sadsajak fjaks kaj kjsa jaklj faj aklj akj kaj ak ja ak" .
		" ajf akjdfkaf ajshfads ad kjaf ha jhas ash asklj ajad\n" .
		"ajkjf aj akjs jash afahsjha siwuwe\t\tiuweq uoweq oiwu r we" .
		"jdkf aksdhsaf ajdskfklsajfkaj akj ajfkasj kaj akj ajsj"
}

sub qtre::macro_3 ()
{
	require "otro.pl";
	my $r= otro::prueba ();
	qtre::insert ($r);
	qtre::delete_char ();
}

sub qtre::macro_4 ()
{
	my $l= qtre::line ();
	qtre::insert (qtre::get_line ($l - 1) . "\n") unless ($l == 0);
	#hola );
}

sub qtre::macro_5 ()
{
	qtre::insert (qtre::line () );
}

sub qtre::macro_6 ()
{
	qtre::insert (qtre::num_lines () );
}

sub qtre::macro_7 ()
{
	# Llena sobradamente la linea de estado (supone 80 columnas)
	my $st= '12345678901234567890';
	#$st= $st . $st . $st . $st;
	$st.= $st; $st.= $st;
	qtre::status ($st);
}

sub qtre::macro_8 ()
{
	my $i;
	for ($i= 0; $i < 2000; ++$i) {
		qtre::right ()
	};
}

sub qtre::macro_9 ()
{
	# Copia la linea actual en la barra de estado.
	# Esto se podria hacer mejor con qtre::get_line,
	# pero asi se muestra el uso de qtre::get_char.
	my $i;
	my $s= '';
	qtre::home ();
	# qtre::get_char devuelve undef al final del fichero.
	#while ( ($i= qtre::get_char () ) ne '' && $i ne "\n") {
	while ( defined ($i= qtre::get_char () ) && $i ne "\n") {
		$s.= $i;
		qtre::right ();
	}
	qtre::status ($s);
}

sub qtre::macro_0 ()
{
	#qtre::right (100);
	my ($begline, $begpos)= qtre::get_beginsel;
	return unless defined $begline;
	my ($endline, $endpos)= qtre::get_endsel;
	qtre::status (join ":", $begline, $begpos, $endline, $endpos);
	++$begline if $begpos;
	--$endline if ! $endpos;
	my $i;
	for ($i= $begline; $i <= $endline; ++$i)
	{
		#qtre::status $i;
		my $l= qtre::get_line $i;
		qtre::replace_line ('# ' . $l, $i) if $l;
	}
}

sub qtre::macro_a ()
{
	#qtre::up () while (qtre::line () > 0);

	qtre::quiet;
	while (qtre::up) { };
	qtre::quiet (0);
}

sub qtre::macro_b ()
{
	# Convierte a mays la linea actual.
	my $l= qtre::get_line ();
	$l =~ tr/[a-z]/[A-Z]/;
	qtre::replace_line ($l);
}

sub qtre::macro_ctrl_c ()
{
	# Copiar linea actual
	#$guarda= qtre::get_line ();
	qtre::set_clipboard qtre::get_line;
	qtre::status ("Copiada");
}

#sub qtre::macro_d ()
#{
#	qtre::insert ("Macro D local\n");
#}

sub qtre::macro_f ()
{
	# Ir al final

	#qtre::goto_line (qtre::num_lines () - 1);

	# Por el camino mas lento

	qtre::quiet;
	my $fin= qtre::num_lines () - 1;
	qtre::down () while (qtre::line () < $fin);
	qtre::quiet 0;
}

#sub qtre::macro_i
sub qtre::macro_ctrl_z
{
	# Invierte 5 lineas.
	my @lins;
	my $i;
	for ($i= 0; $i < 5; ++$i) {
		push (@lins, qtre::get_line () );
		qtre::delete_line ();
	}
	for ($i= 0; $i < 5; ++$i) {
		qtre::insert (pop (@lins) );
		qtre::insert ("\n");
	}
}

sub qtre::macro_k ()
{
	qtre::insert ("\nEsta es la macro k\n");
}

sub qtre::macro_m ()
{
	qtre::goto_line (0);
	my $fin= qtre::num_lines ();
	my $i= 0;
	my $t;
	while ($i < $ fin) {
		$t= qtre::get_line ();
		if (substr ($t, length ($t) - 1, 1) eq "\r")
		{
			#$t= substr ($t, 0, length ($t) - 1);
			chop ($t);
			qtre::replace_line ($t);
		}
		++$i;
		qtre::down ();
	}
}

sub qtre::macro_n ()
{
	# Numera lineas a partir de la 10 o la actual.
	my $i= qtre::line ();
	if ($i > 10) {
		qtre::goto_line (10);
		$i= 10;
	}
	my $fin= qtre::num_lines ();
	while ($i < $fin) {
		qtre::home ();
		qtre::insert ($i . ' ');
		qtre::end ();
		qtre::insert (' ' . $i);
		qtre::down ();
		++$i;
	}
}

sub qtre::macro_p ()
{
	qtre::goto_line (0);
}

sub qtre::macro_q ()
{
	# Crea un monton de lineas
	my $i;
	for ($i= 0; $i < 10000; ++$i) {
		qtre::insert ($i . "\n");
	}
}

sub qtre::macro_r ()
{
	# Rellena unas cuantas lineas
	my $i= 0;
	for ($i= 0; $i < 900; ++$i) {
		qtre::insert ("$i ");
		qtre::insert ("\n") if ($i % 15 == 14);
	}
}

sub qtre::macro_v ()
{
	# Pegar linea
	#qtre::insert ($guarda);
	qtre::insert qtre::get_clipboard;
	qtre::insert ("\n");
	qtre::status ("Pegada");
}

sub qtre::macro_w ()
{
	qtre::menu_rename 'Archivo', '&File';
}

sub qtre::macro_x ()
{
	# Esto es un error:
	qtre::insert ();
	qtre::delete_line ();
}

sub qtre::macro_y ()
{
	# Informa del codigo del caracter bajo el cursor.
	my $i= qtre::get_char ();
	qtre::status (ord ($i) . " \"$i\"");
}

sub qtre::macro_z ()
{
	my $tope= qtre::num_lines () - 1;
	qtre::down () while (qtre::line () < $tope);
}

qtre::menu_add (-1, 'prueba');
qtre::menu_add_option ('prueba', 0, 'pruebecilla', 'macro_k');

sub qtre::replace ()
{
	my $s= shift;
	#qtre::status '-' . $s . '-';
	#sleep 2;
	return '-' . $s . '-';
}

sub qtre::replace2 ()
{
	#my ($s1, $s2, $s3)= @_;
	my $s1= shift; my $s2= shift; my $s3= shift;
	#return "-$s1-$s2-$3";
	#qtre::status '-' . $s1 . '-' . $s2 . '-' . $s3 . '-';
	#sleep 2;
	return '-' . $s1 . '-' . $s2 . '-' . $s3 . '-';
}

{

package qtre;

sub busca ()
{
	my $lines= num_lines;
	my $max= 0;
	my $result= 0;
	my $i;
	for ($i= 0; $i < $lines; ++$i)
	{
		my $len= char_line $i;
		if ($len > $max)
		{
			$max= $len;
			$result= $i;
		}
	}
	goto_line $result;
}

sub nleft ()
{
	my $l= 4000;
	left while ($l-- > 0);
}

sub nright ()
{
	my $l= 4000;
	right while ($l-- > 0);
}

#define_control 'B', 'busca';

define_control 'B', 'nleft';
define_control 'G', 'nright';

}

1;

# Fin de qtre.pl
