// dialog.h
// Revision 10-dec-2003

#include "termstream.h"
#include "history.h"

#include <string>
#include <set>

void centertext (otermstream & ot, int lin, int width, std::string str);

bool dialogGetString (otermstream &ots,
	int & keyend, const std::set <int> & keyender,
	const std::string & title, const std::string & prompt,
	std::string & str, History & history,
	size_t width, std::string::size_type maxlength= std::string::npos);

inline bool dialogGetString (otermstream &ots,
	const std::string & title, const std::string & prompt,
	std::string & str, History & history,
	size_t width, std::string::size_type maxlength= std::string::npos)
{
	int key;
	return dialogGetString (ots, key, std::set <int> (),
		title, prompt, str, history, width, maxlength);
}

void dialogShowText (otermstream & ots, const char * title, const char * str,
	int height, int width);


enum dialogResult { dialogCancel, dialogYes, dialogNo };

dialogResult dialogQuestion (otermstream & ots, const std::string & str);

class DialogOptions {
public:
	DialogOptions (otermstream & ots, const std::string & title);
	~DialogOptions ();
	void add (const std::string & description, bool & option);
	bool do_it ();
private:
	class Internal;
	Internal * pin;
};

// Fin de dialog.h
