// exec.cpp

#include "exec.h"
#include "trace.h"

//#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

void Exec::Command (const std::string & strCommand)
{
	TraceFunc tr ("Exec::Command");

	int handle [2];
	if (pipe (handle) != 0) {
		tr.message ("Error en pipe");
		return;
	}

	pid_t child= fork ();
	switch (child) {
	case pid_t (0):
		// Child
		close (handle [0] );
		dup2 (handle [1], STDOUT_FILENO);
		dup2 (handle [1], STDERR_FILENO);
		close (handle [1] );
		{
			const char * strShell;
			strShell= getenv ("SHELL");
			if (! strShell)
				strShell= "/bin/sh";
			execlp (strShell, strShell,
				"-c", strCommand.c_str (), 0);
		}
		tr.message ("Error en execlp");
		exit (1);
		break;
	case pid_t (-1):
		// Error
		tr.message ("Error en fork");
		close (handle [0] );
		close (handle [1] );
		break;
	default:
		// Parent
		close (handle [1] );
		{
			TraceFunc tr2 ("Exec::Command (leyendo)");
			const size_t bufsize= 1024;
			char buffer [bufsize];
			size_t r;
			while ( (r= read (handle [0], buffer, bufsize) ) > 0) {
				if (r == size_t (-1) ) {
					tr2.message ("Error en read");
					break;
				}
				tr2.message ("Bloque leido");
				for (size_t i= 0; i < r; ++i)
					ExecedSendChar (buffer [i] );
			}
		}
		close (handle [0] );
		waitpid (child, 0, 0);

	} // switch child
}

// Fin de exec.cpp
