/*
	qperl.h
	Revision 7-dec-2003
*/

#ifdef __cplusplus
extern "C" {
#endif

int qperl_init (char * * env, void * data);
void qperl_destroy (void);

typedef enum {
	qpMode,
	qpIsEmpty, qpGetModified, qpSetModified,
	qpUp, qpDown, qpLeft, qpRight, qpHome, qpEnd, qpPageUp, qpPageDown,
	qpGotoLine,
	qpGetChar, qpGetWord,
	qpDeleteChar, qpBackspace, qpDeleteLine, qpReplaceLine,
	qpInsertChar, qpInsert,
	qpLengthSelection, qpGetSelection,
	qpSelectionLimits,
	qpLengthClipboard, qpGetClipboard,
	qpSetClipboard,
	qpLine, qpNumLines, qpCharLine, qpGetLine, qpGetPos, qpGetCol,
	qpGetFileExt, qpGetFileName,
	qpStatus, qpStatusQuestion,
	qpDialogGetString, qpDialogShowText,
	qpDefineControl,
	qpRedraw, qpQuiet,
	qpSelect, qpEndSelect, qpSelectAll, qpCut, qpCopy, qpPaste,
	qpGetKey,
	qpSetAutoindent, qpGetAutoindent, qpSetAutocr, qpGetAutocr,
	qpMenuAdd, qpMenuAddOption,

	//qpWindowNew, qpWindowNext, qpWindowClose,
	qpFileLoad, qpFileNew, qpFileSave, qpFileSaveAs,
	qpFileNext, qpFileClose, qpFileQuit,
	qpHelpAddFunc,
	qpMacro,
	qpFreeString,
	qpFailTest
} qpFuncCode;

typedef struct {
	char * str;
	size_t len;
} qpStringParam;

typedef struct {
	int beginline;
	int beginpos;
	int endline;
	int endpos;
} qpSelectionLimitsParam;

typedef struct {
	const char * question;
	const char * values;
} qpStatusQuestionParam;

typedef struct {
	const char * title;
	const char * prompt;
	char * str;
	unsigned int width;
	unsigned int maxlength;
} qpDialogGetStringParam;

typedef struct {
	const char * title;
	const char * str;
	unsigned int height;
	unsigned int width;
} qpDialogShowTextParam;

typedef struct {
	char key;
	const char * function;
} qpDefineControlParam;

typedef struct {
	int position;
	const char * menuname;
} qpMenuAddParam;

typedef struct {
	const char * menuname;
	int position;
	const char * optionname;
	const char * perlfunc;
} qpMenuAddOptionParam;

typedef struct {
	const char * func;
	const char * desc;
} qpHelpAddFuncParam;

int qpCallback (void *, qpFuncCode, int n, void *);

typedef enum { qpfunction_notfound, qpfunction_failed, qpfunction_ok }
	qpfunctionresult;

qpfunctionresult qperl_function (const char * function, void * data);
qpfunctionresult qperl_function_args (const char * function, void * data,
	int argc, const char * const * argv);

int qperl_eval (const char * str, void * data);

#ifdef __cplusplus
}
#endif

/* Fin de qperl.h */
