// textwindow.cpp
// Revision 1-oct-2004

#include "textwindow.h"

#include "trace.h"
#include "qtreassert.h"

TextWindow::TextWindow () :
	pcount (new size_t),
	ptext (new TextFile),
	lin (0),
	col (0),
	inilin (0),
	inicol (0)
{
	TRACEFUNC (tr, "TextWindow::TextWindow");

	* pcount= 1;
}

TextWindow::TextWindow (const TextWindow & tw) :
	pcount (tw.pcount),
	ptext (tw.ptext),
	lin (tw.lin),
	col (tw.col),
	inilin (tw.inilin),
	inicol (tw.inicol),
	sel (tw.sel)
{
	TRACEFUNC (tr, "TextWindow::TextWindow-copy");

	++ * pcount;
}

TextWindow::~TextWindow ()
{
	TRACEFUNC (tr, "TextWindow::~TextWindow");

	if (-- * pcount == 0)
		delete ptext;
}

void TextWindow::operator = (const TextWindow & tw)
{
	TRACEFUNC (tr, "TextWindow::operator =");

	if (this != & tw)
	{
		if (-- * pcount == 0)
			delete ptext;
		pcount= tw.pcount;
		++ * pcount;
		ptext= tw.ptext;
		lin= tw.lin;
		col= tw.col;
		inilin= tw.inilin;
		inicol= tw.inicol;
		sel= tw.sel;
	}
}

TextFile * TextWindow::text ()
{
	return ptext;
}

// End of textwindow.cpp
