#ifndef INCLUDE_TRACE_H
#define INCLUDE_TRACE_H

// trace.h
// Revision 24-sep-2004

#include <cstddef>
#include <string>

#ifndef NDEBUG

class TraceFunc {
public:
	TraceFunc (const char * strFuncName);
	~TraceFunc ();
	void message (const std::string & str);
	static void show (int);
private:
	const char * strfunc;
	TraceFunc * * previous;
	TraceFunc * next;
};

#define TRACEFUNC(tr,name) \
	TraceFunc tr (name)
#define TRMESSAGE(tr,text) \
	tr.message (text)

#else

#define TRACEFUNC(tr,name)
#define TRMESSAGE(tr,text)

#endif

#endif

// End of trace.h
